﻿# 阅读实验源代码
**main.c文件**  
在main函数中首先创建了二叉树，然后调用PostOrder函数对二叉树进行后序遍历操作，并将产生的后序序列保存在全局变量g_string中，最后销毁了二叉树。  
在main函数的后面，分别定义了二叉树的后序遍历函数PostOrder，以及二叉树的创建函数和销毁函数。其中，后序遍历函数PostOrder的函数体还不完整，留给读者完成。  
**BinaryTree.h文件**  
定义了与二叉树相关的数据结构并声明了相关的操作函数和全局变量。  
# 在演示模式下调试项目
**按照下面的步骤调试项目：**
1.	按F7生成项目。   
2.	在演示模式下，按F5启动调试项目。程序会在观察点函数的开始位置中断。   
3.	重复按F5，直到调试过程结束。   

在调试的过程中，每执行“演示流程”窗口中的一行后，仔细观察“可视化数据”窗口内容所发生的变化，理解后序遍历二叉树的执行过程。“可视化数据”窗口显示的数据信息（如下图），包括：
-	后序遍历二叉树时，由二叉树各个节点的值，按照其被访问的先后顺序所组成的后续遍历字符串。  
-	二叉树的详细信息。包括：  
a)	二叉树节点的值和地址。  
b)	已访问过的结点的底色为灰色，并且在该结点中，用白色的字体标出了访问过的序号。  
c)	在栈中的结点的底色为绿色。  
d)	用红色带箭头的虚线表示出了访问节点的轨迹，在该条虚线的序号表示形成轨迹的先后次序。  
e)	游标指向了当前的节点。  
-	后序遍历二叉树时所使用的两个栈，一个栈用于存储父节点，另一个栈用于存储父节点入栈的次数。包括了二叉树父节点的地址、值、入栈次数，栈的底色为绿色。  

![](./img/11.png)

# 编写源代码并通过验证
**按照下面的步骤继续实验：**
1.	为PostOrder函数编写源代码，要求利用栈实现非递归的后序遍历算法，并生成后序序列字符串。注意，尽量使用已定义的局部变量。
2.	按F7生成项目。如果生成失败，根据“输出”窗口中的提示信息修改源代码中的语法错误。
3.	按Alt+F5启动验证。如果验证失败，可以使用“输出”窗口中的“比较”功能，或者在“非演示模式”下按F5启动调试后重复按F10单步调试读者编写的源代码，从而定位错误的位置，然后回到步骤1。
    提示：在验证过程中，主要是检测后序序列字符串生成的是否正确，所以，为了顺利通过验证，请读者在遍历二叉树的同时一定要在全局变量g_string中生成后序序列字符串。

# 教师参考答案
访问教师参考答案[domain relative url](engintime/ds-lab/teachers-packet/Lab011.git)